#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const int mn=75000+100;
ll a[mn];
ll b[mn];
ll __nzd(ll x,ll y)
{
    if(x==0) return y;
    else return __nzd(y%x,x);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int t;
    cin>>t;
    while(t--)
    {
        int n,m;
        cin>>n>>m;
        for(int i=0;i<n;i++) cin>>a[i];
        for(int i=0;i<m;i++) cin>>b[i];
        sort(a,a+n);
        vector<ll> r;
        for(int i=1;i<n;i++) r.push_back(a[i]-a[i-1]);
        ll nzd=r[0];
        for(int i=1;i<r.size();i++) nzd=__nzd(nzd,r[i]);
        bool ok=true;
        for(int i=0;i<m;i++)
        {
            ll pom=abs(b[i]-a[0]);
            if(pom%nzd==0) ok=false;
        }
        if(ok) cout<<1<<"\n";
        else cout<<0<<"\n";
    }
    return 0;
}